/**
 * Menu control
 **/
(function($){
   
   //Fancy option
    $.fn.ipsp_fancyoption = function(options){
    
        //Setup
        $( '.ipsp-select li:first-child' ).addClass( 'ipsp-item-selected' );
        
        $(this).each( function(){
        
            var option  = $(this);
            var in_menu = false;
            
            $( '.ipsp-selected', option ).click( function(){
                
                var menu   = $(this);
                var select = $( '.ipsp-select', option );
                
                if ( select.is(":visible") ) {
                    select.fadeOut( "fast" );
                    menu.removeClass( 'active' );
                } else {
                    
                    $( '.ipsp-select' ).each( function(){
                        $(this).fadeOut( "fast" );
                        $(this).parents( '.ipsp-selected' ).removeClass( 'active' );
                    });
                    select.fadeIn( "fast" );
                    menu.addClass( 'active' );
                }
                return false;
            });
            $( '.ipsp-select', option ).hover( function(){
                    in_menu = true;
                }, function(){
                    in_menu = false;
            });
            $( "body" ).click(function(){
                if ( ! in_menu ) {
                    $( '.ipsp-select', option ).fadeOut( "fast" );
                    $( '.ipsp-selected', option ).removeClass( 'active' );
                }
            });
            
            $( 'li', option ).click( function(){
            
                var item  = $(this);
                var label = $( '.ipsp-select-label', item ).clone().html();
                var data  = item.data( 'select' );
                $( '.ipsp-selected .ipsp-selected-box', option ).html( label );
                $( '.ipsp-select li', option ).removeClass( 'ipsp-item-selected' );
                item.parents( 'li' ).addClass( 'ipsp-item-selected' );
                $( '.ipsp-input-select', option ).val( data );
                
                //Hide Select box
                $( '.ipsp-select', option ).fadeOut( "fast" );
                $( '.ipsp-selected', option ).removeClass( 'active' );
            });
        
        });
    
    };

    $.fn.ipsp_modal_preview = function(options) {
        
        var defaults  = {
            boxWidth     : 800,
            boxId        : 'pageActionBox',
            modalProcess : function(){}
        };
        var options = $.extend( defaults, options );
        
        var link  = $(this);
        link.click( function() {
        
            var title = link.attr( 'title' );
            var formdata = ipsp_getdataform( $( '#ipsp-manage-form' ) );
            
            options.boxTitle     = title;
            options.ajaxContent  = true;
            options.appendLoader = function( box ){
                var content = $( '<div class="boxContent"></div>' );
                box.append( content );
            };
            
            options.appendAjaxContent = function(){
                
                $.ajax({
                    url: ajaxurl+'?doajax=1&ipsp=1&action=ipsp_preview',
                    type: "POST",
                    data: formdata,
                    dataType: "json",
                    success: function ( result ) {
                    
                        if ( result.status == 1 ) {
                        
                            var contentBox = $( '#'+options.boxId );
                            $( '.boxContent', contentBox ).html(result.preview);
                            $.repositionBox( contentBox, options );
                            $( '#ipsp-countdown-id' ).val( result.id );
                        
                        } else {
                            var actionBox = new $.actionBox(options);
                            actionBox.hideActionBox();
                            alert( 'Preview not available' );
                        }
                    },
                });
            };
            
            //Main
            $.loaderBox(options);
           
            return false;
        });
        
    };

    $.fn.ipsp_save_setting = function(options) {
        
        var defaults  = {
            saveAdd: true,
            boxId : 'pageActionBox',
            modalProcess: function(){}
        };
        var options = $.extend( defaults, options );
        
        var link  = $(this);
        link.click( function() {
        
            var formdata = ipsp_getdataform( $( '#ipsp-manage-form' ) );
            
            options.escCancel      = false;
            options.buttonCancel   = false;
            options.createBoxTitle = false;
            options.bgClickClose   = false;
            options.ajaxContent    = true;
            options.appendLoader   = function( box ){
                var content = $( '<div class="boxContentLoader"><span class="ipsp-loader"></span></div>' );
                box.append( content );
            };
            
            options.appendAjaxContent = function(){
                
                $.ajax({
                    url: ajaxurl+'?doajax=1&ipsp=1&action=ipsp_save',
                    type: "POST",
                    data: formdata,
                    dataType: "json",
                    success: function ( result ) {
                        var actionBox = new $.actionBox(options);
                        actionBox.hideActionBox();
                        if ( options.saveAdd ) {
                            if ( result.status == 1 ) {
                                window.location.href = 'admin.php?page=wp-scarcityplus&action=edit&id='+result.id;
                            } else {
                                ipsp_report_save( result.status );
                            }
                        } else {
                            ipsp_report_save( result.status );
                        }
                        $( '#ipsp-countdown-id' ).val( result.id );
                    },
                });
            };
            
            //Main
            $.loaderBox(options);
           
            return false;
        });
        
        function ipsp_report_save( result )
        {
            if ( result != -1 ) {
                var type = 'updated';
                var msg  = 'Countdown settings successfully saved.';
            } else {
                var type = 'error';
                var msg  = 'Sorry for the inconvenience but the countdown settings can not be saved.';
            }
            var msgHtml = '<div id="message" class="' + type + ' below-h2">'
            msgHtml += '<p>' + msg + '</p>';
            msgHtml += '</div>';
        
            var pos = $( '#wpbody-content' ).position();
            $('html, body').animate({scrollTop: ( pos.top )}, 1000);
            
            $( '#ipsp_messages #message' ).remove();
            $( '#ipsp_messages' ).append( msgHtml );
        }
        
    };
    
    function ipsp_getdataform( parent ) 
    {
        var selector  = 'input[type=text]';
        selector += ', input[type=hidden]';
        selector += ', input[type=password]';
        selector += ', input[type=radio]:checked';
        selector += ', input[type=checkbox]:checked';
        selector += ', textarea';
        selector += ', select';
        
        var data = '';
        
        $( selector, parent ).each( function(){
            var name  = $(this).attr( 'name' );
            var value = encodeURIComponent( $(this).val() );
            
            if ( data != '' ) {
                data += '&';
            }
            data += name+'='+value;
        });
        for ( edId in tinymce.editors ) {
            
            if ( edId.length > 1 ) {
                var value = tinymce.editors[edId].getContent();
                if ( data != '' ) {
                    data += '&';
                }
                data += edId+'='+value;
            }
        }
        return data;
    };
    
})(jQuery);

jQuery(document).ready(function() {

    //Select Countdown Type
    jQuery( '.ipsp-icd-type' ).click( function(){
    
        var value = jQuery(this).val();
        if ( value == 1 ) {
            jQuery( '#ipsp-section-design' ).show();
            jQuery( '#ipsp-section-button' ).show();
            jQuery( '.ipsp-content-limit' ).hide();
            jQuery( '#ipsp-widget-design' ).hide();
        }
        else if ( value == 2 ) {
            jQuery( '#ipsp-section-design' ).hide();
            jQuery( '#ipsp-section-button' ).hide();
            jQuery( '.ipsp-content-limit' ).show();
            jQuery( '#ipsp-widget-design' ).show();
        }
    });
    
    //Select Countdown Expire
    jQuery( '.ipsp-itime-type' ).click( function(){
    
        var value = jQuery(this).val();
        jQuery( '#ipsp-field-time .ipsp-input-time' ).hide();
        jQuery( '.ipsp-info', jQuery(this).parents( '.ipsp-input' ) ).hide();
        jQuery( '.ipsp-wt' ).hide();
        if ( value == 1 ) {
            jQuery( '#ipsp-input-duration' ).show();
            jQuery( '#ipsp-info-time-1' ).show();
            jQuery( '.ipsp-wt.ipsp-wt-duration' ).show();
        }
        else if ( value == 2 ) {
            jQuery( '#ipsp-input-specific' ).show();
            jQuery( '#ipsp-info-time-2' ).show();
            jQuery( '.ipsp-wt.ipsp-wt-date' ).show();
        }
        else if ( value == 3 ) {
            jQuery( '#ipsp-input-visit' ).show();
            jQuery( '#ipsp-info-time-3' ).show();
            jQuery( '.ipsp-wt.ipsp-wt-visit' ).show();
        }
    });
    
    //Select Message Box
    jQuery( '#ipsp-use-confirm' ).click( function(){
    
        if ( jQuery(this).is(':checked') ) {
            jQuery( '#ipsp-input-confirm' ).show();
        } else {
            jQuery( '#ipsp-input-confirm' ).hide();
        }
    });
    
    //Select Button
    jQuery( '#ipsp-use-button' ).click( function(){
    
        if ( jQuery(this).is(':checked') ) {
            jQuery( '#ipsp-button-options' ).show();
        } else {
            jQuery( '#ipsp-button-options' ).hide();
        }
    });
    
    //Select Content
    jQuery( '.ipsp-input-content h4' ).click( function(){
    
        jQuery( '.ipsp-content-editor' ).hide();
        jQuery( '.ipsp-input-content .ipsp-ic' ).text( '[+]' );
        var root = jQuery(this).parents( '.ipsp-input-content' );
        jQuery( '.ipsp-content-editor', root ).show();
        jQuery( '.ipsp-ic', root ).text( '[-]' );
        return false;
    });
    
    //Delete countdown data
    jQuery( '.ip_countdownDelete' ).each( function(){
        
        var button = jQuery(this);
        button.click( function(){
        
            var id = button.attr( 'href' ).replace( '#toDeleteCountdown_', '' );
            jQuery( '.ipsp_loader_small' ).remove();
            button.addClass( 'button-disabled' );
            button.attr( 'disabled', 'disabled' );
            var loader = '<div class="ipsp_loader_small"></div>';
            button.after( loader );
            
            jQuery.ajax({
                url: ajaxurl,
                type: "POST",
                dataType: "json",
                data: 'doajax=1&ipsp=1&action=ipsp_delete&id='+id,
                success: function (result) {
                    
                    if ( result.status == '-1' ) {
                        ipsp_setMessage( 'Failed to remove the countdown', 'error' );
                    } else {
                        ipsp_setMessage( 'Successfully remove the countdown', 'updated' );
                        var tr = button.parents( 'tr' );
                        tr.hide( 'blind' );
                        setTimeout( function(){
                            tr.remove();
                        }, 600);
                    }
                    button.removeClass( 'button-disabled' );
                    button.removeAttr( 'disabled', 'disabled' );
                    jQuery( '.ipsp_loader_small' ).remove();
                    
                },
                error: function () {
                    alert( "Error in Deleting countdown" );
                },
            });
            
            return false;
        });
    });
    
    function ipsp_setMessage( msg, type ) 
    {
        var pos = jQuery( '#wpbody-content' ).position();
        jQuery('html, body').animate({scrollTop: ( pos.top )}, 1000);
        
        jQuery( '#ipsp_messages #message' ).remove();
        var msgHtml = '<div id="message" class="' + type + ' below-h2">'
        msgHtml += '<p>' + msg + '</p>';
        msgHtml += '</div>';
        
        jQuery( '#ipsp_messages' ).append( msgHtml );
    }
    
    function ipsp_setInputMessage( msg, type, input ) 
    {
        jQuery( '.inputMsg' ).remove();
        var msgHtml = '<div class="inputMsg ' + type + '">'
        msgHtml += '<p>' + msg + '</p>';
        msgHtml += '</div>';
        
        jQuery( input ).before( msgHtml );
    }

    //Fancy Option
    jQuery( '.ipsp-menu' ).ipsp_fancyoption();
    
    //Color picker
    jQuery('.color-picker').wpColorPicker();
    
    //Preview Modal
    jQuery( '#ipsp-modal-preview' ).ipsp_modal_preview();
    
    //Save Setting
    jQuery( '#ipsp_add_countdown' ).ipsp_save_setting();
    jQuery( '#ipsp_save_setting' ).ipsp_save_setting({saveAdd: false});
});